#CONTROLCODES 1
#INCLUDE "/BASIC/INCLUDES/STANDARD.DEF"


FIFOFULL = %10000000
BIT16.ON = %00100000
STEREO.ON = %00010000
VOLMASK = %11110000
VOLMAX = %11111111
DefaultVolume = 12
MaxVolume = 15

IsPaused = 0
IsFinished = 0
PlayFinished = 0
UserStop = 0
SaveTimer = 0


MAIN:
  DEF FN SIGNED.BYTE(N) = N+256*(N>127)
  OB = PEEK(1):BANK PEEK(0),0
  ROM.VERSION=FN SIGNED.BYTE(PEEK($FF80))
  GOOD.ROM = (ROM.VERSION < -45) OR (ROM.VERSION >= 45)
  IF NOT GOOD.ROM THEN PRINT "{WHT}ROM VERSION {RED}";ROM.VERSION;"{WHT} NOT SUPPORTED. PLEASE UPGRADE.":END
  IF ROM.VERSION < -47 OR ROM.VERSION >= 47 THEN FASTMODE = -1
  BANK PEEK(0),OB
  ROM.VERSION = ABS(ROM.VERSION)
  VPOKE 1,$FA05,13

StartPCM.Play = $A02D
ContinuePCM.Play= $A019


DEF FN ROUND(X) = INT(X+.5)
PRINT "{ISO ON}"
SCREEN $80
PRINT "TESTING FILE SYSTEM"
GOSUB TestFileSystem
GOSUB HIDEALL
BLOAD "WAVMODULE.BIN",8,3,$A000
COLOR 1,0
F$="THIN8X8.PF":GOSUB FILEEXISTS
IF FE% THEN BVLOAD "THIN8X8.PF",8,1,$F000
GOSUB FIXCURSOR
RECT 0,0,319,239,0
BVLOAD "NOTES.BIN",8,0,0
CLS
GETMYWAVE:
CLOSE 6
  GOSUB HIDETEXT
  CLS
  COLOR 1,0
  LOCATE 29,2:PRINT "{WHT}ENTER THE WORD {YEL}<{LIGHT GREEN}EXIT{YEL}>{WHT} TO END."
  LOCATE 1,1
  PRINT:PRINT
  PRINT " ENTER WAVE or ZCM File Name {GRN} ";
  PRINT
  GOSUB SHOWALL
ELOOP:
  IT=4:IX=2:IY=5:ML=37:COLOR 5,11
  GOSUB STRINGGET
  S$=IS$
  IF S$="" THEN FMDRUM 7,87:GOTO ELOOP
  GOSUB UCASE
  F$=S$
  GOSUB GET.FileExtension
  COLOR 1,0
  IF F$="EXIT" THEN WAVESEND
  IF EXT$="" THEN GOSUB FixFile
  GOSUB FILEEXISTS
  IF NOT FE% THEN PRINT:PRINT "{CR} ";"{BELL}{RED}";F$;"{WHT}  NOT FOUND!":SLEEP 90:GOTO GETMYWAVE
  WAV$=F$
  IF EXT$=".WAV" THEN GOSUB LOADWAVE:IF NOT IsSupported THEN PRINT:PRINT " {LIGHT RED}{BELL}WAVE FILE ERROR {RED}!{WHT}":PRINT:SLEEP 90:GOTO GETMYWAVE
  IF EXT$=".WAV" AND IsSupported THEN STARTWAV
  IF EXT$=".ZCM" THEN GOSUB GetZCMHeader:GOTO STARTWAV
  PRINT "{CR}{CR} {RED}";EXT$;"{BELL}{LIGHT RED} NOT SUPPORTED {RED}!{WHT}":PRINT:SLEEP 90:GOTO GETMYWAVE
STARTWAV:
  GOSUB HIDETEXT
  GOSUB PRNTStreamData
  LOCATE 29,4:PRINT "Playing{YEL}:{LIGHT GREEN} ";F$;
  LOCATE 26,4:COLOR 2,6
  IF FASTMODE THEN GOSUB CHECKRATE
  GOSUB SHOWTEXT
  GOSUB PLAY.Wave.File
  ENDTIME = TI
  IF WASERROR THEN SLEEP 90:GOTO GETMYWAVE

GOTO GETMYWAVE

WAVESEND:
 COLOR 1,0
 GOSUB SHOWALL
 SCREEN 1
 PRINT
 PRINT
 END

FixFile:
  T1$=F$
  T2$=F$+".WAV"
  T3$=F$+".ZCM"
  F$=T2$:GOSUB FILEEXISTS
  IF FE% THEN EXT$=".WAV":RETURN
  F$=T3$:GOSUB FILEEXISTS
  IF FE% THEN EXT$=".ZCM":RETURN
  F$=T1$
  RETURN

LOADWAVE:
   GOSUB LoadWAVEHeader
   GOSUB ParseRIFFHeader
   RETURN

PLAY.Wave.File:
   UserEnded = 0
   PAUSED = 0
   FillLoopCount = 6
   IF IsHostFS THEN FillLoopCount = 12
   IF BytesPerSecond > 79999 THEN FillLoopCount = FillLoopCount+1
   IF BytesPerSecond > 100000 THEN FillLoopCount = FillLoopCount+1
   POKE A.REG, FillLoopCount
   POKE X.REG, 6
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   POKE R1L, $FF
   BANK 3
   SYS StartPCM.Play
getPKey:
   rKey = PEEK(R2L)
   IF rKey = 27 THEN UserEnded = -1
   IF rKey = 0 OR rKey = 27 THEN CLOSE 6:COLOR 1,0:RETURN
   IF rKey = 32 THEN GOSUB Wait32
   GOTO getPKey


Wait32:
  GOSUB SaveCursor.AndColor
  LOCATE 25, 4
  COLOR 1,11:PRINT "{LIGHT GREEN}*{YEL} PAUSED {LIGHT GREEN}*"
  FOR I = 0 TO 1 STEP 0
    GET K$
    K=ASC(K$)
    IF K=32 THEN GOSUB MSGCLR:I=1
    IF K=27 THEN POKE R2L,27:I=1
  NEXT I
  RETURN

MSGCLR:
  POKE R2L,0
  COLOR 1,0
  LOCATE 25,4
  PRINT RPT$(32,11);
  GOSUB RestoreCursor.AndColor
  SYS ContinuePCM.Play
  RETURN

CHECKRATE:
  IF IsHostFS THEN RETURN
  IF BytesPerSecond > 120000 THEN DOS "U0>B3":RETURN
  DOS "U0>B0"
  RETURN

## ShowHDRData:
##  PRINT
##  PRINT "Is Wave: ";IsWave
##  PRINT
##  PRINT "PCM Bits: ";PCMBits
##  PRINT
##  PRINT "Channels: ";NumChannels
##  PRINT
##  PRINT "Sample Rate: ";SampleRate
##  PRINT
##  PRINT "Is Supported: ";IsSupported
##  PRINT
##  PRINT "Is HOSTFS: ";IsHostFS
##  PRINT
##  PRINT "VERA Rate: ";VERA.RATE
##  PRINT
##  PRINT "VERA Cfg: ";BIN$(VERA.CFG)
##  PRINT
##  PRINT "Bytes per Second: ";BytesPerSecond
##  RETURN

PRNTStreamData:
 COLOR 1,0:CLS:PRINT
 PRINT "{LIGHT GREEN}";PCMBits;"{WHT}bit{LIGHT GREEN}";
 IF IsStereo THEN PRINT " Stereo";
 IF NOT IsStereo THEN PRINT " Mono";
 PRINT "{WHT} stream{GREY 1}."
 PRINT
 IF IsWave THEN PRINT "{WHITE} Origin Sample rate:{LIGHT GREEN}";SampleRate;"{GRN}Hz{GREY 1}.{CR}    "
 PRINT "{WHITE} VERA Play rate:{LIGHT GREEN}";FN ROUND((VERA.RATE/128)*48828.15);"{GRN}Hz{GREY 1}."
 PRINT
 PRINT "{LIGHT GREEN}";BytesPerSecond;"{WHT}Bytes{GRN}/{WHT}Sec from Disk{GREY 1}."
 PRINT
 RETURN

ParseRIFFHeader:
  IsWave = (LEFT$(RIFFHDR$,4) = "RIFF") AND (MID$(RIFFHDR$,9,4)="WAVE")
  PCMBits = ASC(MID$(RIFFHDR$,35,1))
  TMP1 = ASC(MID$(RIFFHDR$,21,1))
  TMP2 = ASC(MID$(RIFFHDR$,22,1))
  NumChannels = ASC(MID$(RIFFHDR$,23,1))
  TMP4 = (TMP1) + (256*TMP2)
  IsPCM = (TMP4=1)
  TMP1 = ASC(MID$(RIFFHDR$,25,1))
  TMP2 = ASC(MID$(RIFFHDR$,26,1)) * 256
  TMP3 = ASC(MID$(RIFFHDR$,27,1)) * 65536
  SampleRate = TMP1+TMP2+TMP3
  VERA.RATE = FN ROUND((SampleRate / 48828.15) * 128)
  IsStereo = (NumChannels=2)
  IsSupported = (IsWave AND (PCMBits=16)) AND IsPCM AND ((NumChannels > 0) AND (NumChannels < 3))
  VERA.CFG=0
  IF NOT IsSupported THEN RETURN
  VERA.CFG = (VERA.CFG OR BIT16.ON)
  IF IsStereo THEN VERA.CFG = (VERA.CFG OR STEREO.ON)
  VERA.CFG = VERA.CFG OR DefaultVolume
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)*2
  IF IsStereo THEN BytesPerSecond = BytesPerSecond*2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

LoadWAVEHeader:
   RIFFHDR$ = RPT$(44,44)
   OPEN 6,8,6,F$+",S,R"
     POKE X.REG, 6
     SYS CHKIN
     POKE A.REG, 44
## GET A POINTER TO THE WAVEHDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(RIFFHDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     RETURN

GetZCMHeader:
  IsWave = FALSE
  OPEN 6,8,6,F$+",S,R"
  FOR I = 1 TO 6:GET# 6, X$:NEXT I
  GET# 6, X$
  VERA.CFG = ASC(X$)
  GET# 6, X$
  VERA.RATE = ASC(X$)
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)
  PCMBits = 8
  IF (VERA.CFG AND BIT16.ON) = BIT16.ON THEN PCMBits=16:BytesPerSecond = BytesPerSecond*2
  IsStereo = ((VERA.CFG AND STEREO.ON) = STEREO.ON)
  VERA.CFG = ((VERA.CFG AND %11110000) OR DefaultVolume)
  IF IsStereo THEN BytesPerSecond = BytesPerSecond * 2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

TestFileSystem:
 F$="TESTFILE":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:TESTFILE,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"TESTFILE,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 63
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN


#INCLUDE "/BASIC/INCLUDES/STANDARD.BI"
